use crate::app_config::AppConfig;
use actix_web::HttpResponse;

/// Serve robots.txt (disallow ranking)
pub async fn robots_txt() -> HttpResponse {
    HttpResponse::Ok()
        .content_type("text/plain")
        .body("User-agent: *\nDisallow: /\n")
}

#[derive(serde::Serialize)]
pub struct ServerConstraints {
    // TODO
}

impl Default for ServerConstraints {
    fn default() -> Self {
        Self {
            // TODO
        }
    }
}

#[derive(serde::Serialize)]
struct ServerConfig {
    auth_disabled: bool,
    oidc_provider_name: &'static str,
    constraints: ServerConstraints,
}

impl Default for ServerConfig {
    fn default() -> Self {
        Self {
            auth_disabled: AppConfig::get().is_auth_disabled(),
            oidc_provider_name: AppConfig::get().openid_provider().name,
            constraints: Default::default(),
        }
    }
}

/// Get server static configuration
pub async fn config() -> HttpResponse {
    HttpResponse::Ok().json(ServerConfig::default())
}
